﻿using System;
using System.Collections.Generic;
using System.Text;


namespace jordan_svd
{
    /**
     * Class that used for performance measurment
     */ 
    public class PerformanceCounter
    {

        [System.Runtime.InteropServices.DllImport("Kernel32.dll")]
        public static extern bool QueryPerformanceCounter(out long perfcount);

        [System.Runtime.InteropServices.DllImport("Kernel32.dll")]
        public static extern bool QueryPerformanceFrequency(out long freq);

        [System.Runtime.InteropServices.DllImport("Kernel32.dll")]
        public static extern long GetTickCount();


        public long startPerf;
        public long stopPerf;

        public long totalPref;

        public long tickCount;

        /**
         * The default constructor
         */ 
        public PerformanceCounter()
        {
            totalPref = 0;
        }

        /**
         * Starts the count
         */ 
        public void startCount()
        {
            startPerf = QueryPerformanceCounter();
        }

        /**
         * Stops the count and the result is stored in the totalPref.
         */ 
        public void stopCount()
        {
            stopPerf = QueryPerformanceCounter();
            totalPref = stopPerf - startPerf ;
        }


        /**
         * Gets the current 'Ticks' on the performance counter
         * Returns Long indicating the number of ticks on the performance counter
         */
        public long QueryPerformanceCounter()
        {
            long perfcount;
            QueryPerformanceCounter(out perfcount);
            return perfcount;
        }

        /**
         * Gets the number of performance counter ticks that occur every second
         * Return the number of performance counter ticks that occur every second
         */
        public long QueryPerformanceFrequency()
        {
            long freq;
            QueryPerformanceFrequency(out freq);
            return freq;
        }

    }

}
