﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

namespace jordan_svd
{
    /**
     * Zero polynomial matrix calculation
     */
    public class ZeroPolynomialMatrixCalculation
    {
        /**
         * The input elements. An array list of input 2D arrays
         */ 
        public ArrayList Cn;

        /**
         * The numper of lines of the input array
         */ 
        public int pGrames;

        /**
         * The number of columns of the input array
         */ 
        public int mStiles;


        public int nValue;

        public int lamda;
        public int kapa;

        public double [,]E;
        public double[,] F;
        

        /**
         * The time of the algorithm execution
         */ 
        public long totalTime;

        public long svdTotalTime;
        public long svdCount;

        public long eigTotalTime;

        /**
         * The real part of the result
         */ 
        public double[] resultReal;

        /**
         * The imaginary part of the result.
         */ 
        public double[] resultIm;

        /**
         * The default constructor
         */ 
        public ZeroPolynomialMatrixCalculation()
        {
        }

        /**
         * Initialises the polynomial matrix
         */
        public void setPolionimikoPinaka(ArrayList p)
        {
            Cn = p;
        }

        /**
         * Solves the polynomial matrix
         */
        public void solve()
        {
            jordan_svd.qrbsvd Fpsvd;

            svdCount = 0;
            svdTotalTime = 0;
            PerformanceCounter ctsvd = new PerformanceCounter();
            // For the time calculation
            PerformanceCounter ct = new PerformanceCounter();
            ct.startCount();

            // The first array
            double[,] first;
            
            first = (double[,])Cn[0];

            // We get the line and the column dimension of the matrix
            pGrames = first.GetLength(0); 
            mStiles = first.GetLength(1); 

            nValue = Cn.Count - 1;

            lamda = pGrames + (nValue - 1) * mStiles;
            kapa = mStiles * nValue;

            // we generate the initial E and F
            generateEandF();
            
            jordan_svd.qrbsvd Esvd;
            int r;
            double[,] fmikro;
            double[,] Fp;
            

            for (;;)
            {
                svdCount = svdCount + 1;
                ctsvd = new PerformanceCounter();
                ctsvd.startCount();
                Esvd = new jordan_svd.qrbsvd();
                Esvd.solveAlgSvd(E);
                ctsvd.stopCount();
                svdTotalTime = svdTotalTime + ctsvd.totalPref;

                r = Esvd.Rank();
                if (r == 0)
                {
                    general_case(GMatrix.GetClone(F), GMatrix.GetClone(E) , out resultReal , out resultIm);
                    break;
                }
                else if (r == lamda)
                {
                    if (r == kapa)
                    {
                        general_case(GMatrix.GetClone(F), GMatrix.GetClone(E), out resultReal, out resultIm);
                        break;

                    }
                    else // r != kapa
                    {
                        // we get the V 
                        double[,] V1 = GMatrix.GetClone(Esvd.V);
                        double[,] V1Trans = GMatrix.Transpose(V1);

                        fmikro = GMatrix.Multiply(F, V1Trans);
                        
                        int fmrowd = fmikro.GetLength(0);
                        int fmcold = fmikro.GetLength(1);
                        Fp = GMatrix.GetMatrix2(0, fmrowd, fmcold - (kapa - r), fmcold, fmikro);

                        svdCount = svdCount + 1;
                        ctsvd = new PerformanceCounter();
                        ctsvd.startCount();
                        Fpsvd = new jordan_svd.qrbsvd();
                        Fpsvd.solveAlgSvd(Fp);
                        ctsvd.stopCount();
                        svdTotalTime = svdTotalTime + ctsvd.totalPref;


                        int fprowd = Fp.GetLength(0);
                        int num = fprowd - Fpsvd.Rank();

                        double[,] TU = GMatrix.GetClone(Fpsvd.U);
                        int turowd = TU.GetLength(0);
                        int tucold = TU.GetLength(1);
                        double[,] T = GMatrix.GetMatrix2(0, turowd, (tucold - num), tucold,TU);
                        lamda = T.GetLength(0);//T.RowDimension;
                        kapa = r;
                        double[,] Etmp = GMatrix.Multiply(GMatrix.Multiply(T, E), V1Trans);

                        E = GMatrix.GetMatrix2(0, Etmp.GetLength(0), 0, r, Etmp);

                        double[,] Ftmp = GMatrix.Multiply(GMatrix.Multiply(T, F), V1Trans);
                        F = GMatrix.GetMatrix2(0, Ftmp.GetLength(0), 0, r,Ftmp);
                        //sel 3
                    }
                } // end *1 r == lamda
                else  // sel 3
                {
                    double[,] U1 = GMatrix.GetClone(Esvd.U);
                    double[,] U1Trans = GMatrix.Transpose(U1);

                    fmikro = GMatrix.Multiply(U1Trans, F);

                    int fmikrorowd = fmikro.GetLength(0);
                    int fmikrocold = fmikro.GetLength(1);
                    
                    Fp = GMatrix.GetMatrix2(fmikrorowd - (lamda - r), fmikrorowd, 0, fmikrocold,fmikro);

                    svdCount = svdCount + 1;
                    ctsvd = new PerformanceCounter();
                    ctsvd.startCount();
                    Fpsvd = new jordan_svd.qrbsvd();
                    Fpsvd.solveAlgSvd(Fp);
                    ctsvd.stopCount();
                    svdTotalTime = svdTotalTime + ctsvd.totalPref;
                    
                    int num = Fp.GetLength(1) - Fpsvd.Rank();
                    double[,] WV = GMatrix.GetClone(Fpsvd.V);

                    int wvrowd = WV.GetLength(0);
                    int wvcold = WV.GetLength(1);
                    double[,] W = GMatrix.GetMatrix2(0, wvrowd, wvcold - num, wvcold,WV);

                    lamda = r;
                    kapa = W.GetLength(1);

                    double[,] Etmp = GMatrix.Multiply(GMatrix.Multiply(U1Trans, E), W);
                    
                    E = GMatrix.GetMatrix2(0, r, 0, Etmp.GetLength(1),Etmp);

                    double[,] Ftmp = GMatrix.Multiply(GMatrix.Multiply(U1Trans, F), W);
                    F = GMatrix.GetMatrix2(0, r, 0, Ftmp.GetLength(1), Ftmp);
                }
            }
            // We stop the time calculation
            ct.stopCount();
            totalTime = ct.totalPref;
        }

        /**
         * Generates the first E and F
         */ 
        public void generateEandF()
        {
            double[,] first;
            double[,] trigonikos;
            int miden1Rows ,miden1Cols ;
            int miden2Rows , miden2Cols;
            first = (double[,])Cn[0];

            miden1Rows = pGrames;
            miden1Cols = kapa - mStiles;

            miden2Rows = kapa - mStiles;
            miden2Cols = mStiles;

            int gramesE = pGrames + miden2Rows;
            int stilesE = mStiles + miden2Rows;

            E = GMatrix.Zeroes(gramesE, stilesE);

            trigonikos = GMatrix.Identity((kapa - mStiles), (kapa - mStiles));


            // we set the Cn values
            GMatrix.SetMatrix0(0, pGrames, 0, mStiles, E, first);

            // midenikos -1 
            for (int i = 0; i < pGrames; i++)
            {
                for (int j = mStiles; j < stilesE; j++)
                {
                    E[i, j] = 0.0;
                }
            }

            // midenikos 2
            for (int i = pGrames; i < gramesE; i++)
            {
                for (int j = 0; j < miden2Rows; j++)
                {
                    //E.SetElement(i, j, 0.0);
                    E[i, j] = 0.0;
                }
            }

            // we append te trigonikos
            GMatrix.SetMatrix0(pGrames, gramesE, mStiles, stilesE, E, trigonikos);

            double [,] cl;
            int stilesF = mStiles * (Cn.Count -1);
            int gramesF = pGrames + miden2Rows;
            
            //F = new GeneralMatrix(gramesF , stilesF , 0);
            F = GMatrix.Zeroes(gramesF, stilesF);

            // mul -1 and set 
            for (int i = 1; i < Cn.Count; i++)
            {
                cl = GMatrix.GetClone((double[,])Cn[i]);
                for (int ix = 0; ix < pGrames; ix++)
                {
                    for (int jx = 0; jx < mStiles; jx++)
                    {
                        cl[ix, jx] = (-1) * cl[ix, jx];
                    }
                }
                // we append the cl to F
                GMatrix.SetMatrix(0, (i - 1) * mStiles, F, cl);

            }
            GMatrix.SetMatrix(pGrames, 0,F, trigonikos);
        }


        /**
         * Checks if we have result. 
         * If so ... initialize the real and the imaginary part of the result
         */
        public void general_case(double[,] mF, double[,] mE , out double [] wr, out double []  wi)
        {
            if (isZeroMatrix(mE))
            {
                wr = null;
                wi = null;
                return;
            }

            double [,] Einv = GMatrix.GetClone(mE);
            alglib.matinvreport rep;
            int info;
            // we get the inverse
            alglib.rmatrixinverse(ref Einv,out info,out rep);
            double[,] mul = GMatrix.Multiply(Einv , mF);
            int size = mul.GetLength(0);
            wr = new double[size];
            wi = new double[size];
            double [,] vl = new double[size,size];
            double [,] vr = new double[size,size];
            // Gets the Eigenvalues. The output wr , wi is our result.

            PerformanceCounter ctsvd = new PerformanceCounter();
            ctsvd = new PerformanceCounter();
            ctsvd.startCount();
            alglib.rmatrixevd( mul , size,3, out wr,out wi,out vl,out vr);
            ctsvd.stopCount();
            eigTotalTime = ctsvd.totalPref;
        }

        /**
         * Returns true if the specified matrix is zero matrix.
         */ 
        public bool isZeroMatrix(double[,] mz)
        {
            bool result = true;
            int rowd = mz.GetLength(0);
            int cold = mz.GetLength(1);
            for (int i = 0; i < rowd; i++)
            {
                for (int j = 0; j < cold; j++)
                {
                    if (mz[i, j] != 0.0) return false;
                }
            }

            return result;
        }


        public int[] calculatePolaplotita()
        {
            double tol = 10E-8;

            int []result = new int[resultReal.Length];

            int[] used = new int[resultReal.Length];
            for ( int i = 0 ; i < resultReal.Length ; i++) {
                used[i] = -1;
                result[i] =1;
            }

            for (int i = 0; i < resultReal.Length; i++)
            {
                if (used[i]!=-1) continue;
                for (int j = i + 1; j < resultReal.Length; j++)
                {
                    double dif = Math.Abs(resultReal[i] - resultReal[j]);
                    double dif2 = Math.Abs(resultIm[i] - resultIm[j]);
                    if (dif < tol && dif2 < tol)
                    {
                        used[j] = i;
                        result[i]++;
                    }
                }
            }

            for (int i = 0; i < resultReal.Length; i++)
            {
                if (used[i] != -1)
                {
                    result[i] = result[used[i]];
                }
            }

            return result;
        }

        public bool condtest(ArrayList varargin)
        {
            bool result = true;

            // we define the tolerance
            double tol = 1.0E-8;

            
            // We get the line and the column dimension of the matrix

            int n = varargin.Count - 1;

            double[,] first = (double[,])varargin[0];
            int p = first.GetLength(0); // 
            int m = first.GetLength(1);

            int l = p + (n - 1) * m;
            int k = n * m;

            // define E1 , F1
            double [,] E1 = new double[l, k];
            double [,] F1 = new double[l, k];

            // first block E1
            double[,] Cl = GMatrix.GetClone((double[,])varargin[0]);
            GMatrix.SetMatrix(0, 0, E1, Cl);
            double[,] z1 = GMatrix.Zeroes(p, k - m);
            GMatrix.SetMatrix(0, m, E1, z1);

            // second block E1
            double[,] z2 = GMatrix.Zeroes(k-m, m);
            GMatrix.SetMatrix(p, 0, E1, z2);
            GMatrix.SetMatrix(p, m, E1, GMatrix.Identity(k - m, k - m));


            //first block F1
            for ( int i = 1 ; i < varargin.Count ; i++) {
                double [,] prt = (double[,])varargin[i];
                double[,] prtM = GMatrix.MulArrayWithNum(-1, prt);
                GMatrix.SetMatrix(0, (i - 1) * m, F1 , prtM); 
            }

            //second block F1
            GMatrix.SetMatrix(p, 0, F1, GMatrix.Identity(k - m, k - m));
            GMatrix.SetMatrix(p, m, F1, GMatrix.Zeroes(k - m, m));

            //////////////////////////////////////

            // define E1 , F1
            double[,] E2 = new double[l, k];
            double[,] F2 = new double[l, k];


            // first block E2
            double[,] Cl0 = GMatrix.GetClone((double[,])varargin[varargin.Count-1]);
            GMatrix.SetMatrix(0, 0, E2, Cl0);
            double[,] ze21 = GMatrix.Zeroes(p, k - m);
            GMatrix.SetMatrix(0, m, E2, ze21);


            // second block E2
            double[,] ze22 = GMatrix.Zeroes(k - m, m);
            GMatrix.SetMatrix(p, 0, E2, ze22);
            GMatrix.SetMatrix(p, m, E2, GMatrix.Identity(k - m, k - m));


            //first block F2
            int ki = 0;
            for (int i = varargin.Count-2; i > -1; i--)
            {
                double[,] prt = (double[,])varargin[i];
                double[,] prtM = GMatrix.MulArrayWithNum(-1, prt);
                GMatrix.SetMatrix(0, ki * m, F2, prtM);
                ki++;
            }

            //second block F2
            GMatrix.SetMatrix(p, 0, F2, GMatrix.Identity(k - m, k - m));
            GMatrix.SetMatrix(p, m, F2, GMatrix.Zeroes(k - m, m));


            int sz = F1.GetLength(0);
            double [] p1 = GMatrix.ZeroesOne(sz);
            double[] p2 = GMatrix.ZeroesOne(sz);
            double[] rt = GMatrix.ZeroesOne(sz);

            for (int cnt = 0; cnt < sz; cnt++)
            {
                double [,] E1inv = GMatrix.GetClone(E1);
                alglib.matinvreport rep;
                int info;
                // we get the inverse
                alglib.rmatrixinverse(ref E1inv,out info,out rep);    
                double [,] forTrace = GMatrix.Pow( GMatrix.Multiply(E1inv , F1) , cnt);
                p1[cnt] = GMatrix.Trace(forTrace);


                double[,] E2inv = GMatrix.GetClone(E2);
                // we get the inverse
                alglib.rmatrixinverse(ref E2inv, out info, out rep);
                forTrace = GMatrix.Pow(GMatrix.Multiply(E2inv, F2), cnt);
                p2[cnt] = GMatrix.Trace(forTrace);


                if (Math.Abs(p1[cnt] - p2[cnt]) < tol  )
                {
                    rt[cnt] = 1;
                }
                else
                {
                    result = false;
                }
            }


            return result;
        }

    }
}
