function z = condtest (varargin)

% tolerance
tol = 1e-8;

% polynomial degree
n = numel (varargin) - 1;

% dimensions of matrix C
[p, m] = size (varargin{1});

% E and F formation
l = p + (n - 1) * m;
k = n * m;

E1 = [varargin{1}, zeros(p, k - m); zeros(k - m, m), eye(k - m)];
F1 = [-cell2mat(varargin(2:end)); eye(k - m), zeros(k - m, m)];

E2 = [varargin{end}, zeros(p, k - m); zeros(k - m, m), eye(k - m)];
F2 = [-cell2mat(varargin(end-1:-1:1)); eye(k - m), zeros(k - m, m)];

sz = size (F1, 1);
p1 = zeros (1, sz);
p2 = p1;
rt = p2;

for cnt = 1:sz
  p1(cnt) = trace ( (inv (E1) * F1)^cnt );
  p2(cnt) = trace ( (inv (E2) * F2)^cnt );
  if ( abs (p1(cnt) - p2(cnt)) < tol )
    rt(cnt) = 1;
  else
    rt(cnt) = 0;
  end
end

if ( isequal (unique (rt), 1) )
  z = 1; % true: equal zeros
else
  z = 0; % false
end

