function z = zersvd (varargin)

% polynomial degree
n = numel (varargin) - 1;

% dimensions of matrix C
[p, m] = size (varargin{1});

% E and F formation
l = p + (n - 1) * m;
k = n * m;
E = [varargin{1}, zeros(p, k - m); zeros(k - m, m), eye(k - m)];
F = [-cell2mat(varargin(2:end)); eye(k - m), zeros(k - m, m)];

while (1)
[U, S, V] = svd (E);
r = rank (E);

keyboard;

if ( r == 0 )
  z = casevii (E);
  return;
elseif ( r == l )
  if ( r == k )
    z = casevii (E, F);
    return;
  else
    f = F * V';
    Fp = f(:, end - k + r + 1 : end);
    [TU, TS, TV] = svd (Fp);
    T = TU(:, end - size(Fp, 1) + rank(Fp) + 1 : end);
    l = size (T, 1);
    k = r;
    Etmp = T * E * V';
    E = Etmp(:, 1 : r);
    Ftmp = T * F * V';
    F = Ftmp(:, 1 : r);
  end
else
  f = U' * F;
  Fp = f(end - l + r + 1: end, :);
  [WU, WS, WV] = svd (Fp);
  W = WV(:, end - size(Fp, 2) + rank(Fp) + 1 : end);
  l = r;
  k = size(W, 2);
  Etmp = U' * E * W;
  E = Etmp(1 : r, :);
  Ftmp = U' * F * W;
  F = Ftmp(1 : r, :);
end
end

function z = casevii (E, F)

if E == zeros (size (E))
  z = [];
else
  z = eig (inv(E) * F);
end
